#include <PinChangeInterrupt.h>
#include <IRremote.h>

// Sleep tuorial from here: http://www.technoblogy.com/show?KX0
#include <avr/sleep.h>

// Utility macros
#define adc_disable() (ADCSRA &= ~(1<<ADEN)) // disable ADC (before power-off)
#define adc_enable()  (ADCSRA |=  (1<<ADEN)) // re-enable ADC

IRsend irsend;

// Button Pins
#define SW1 1
#define SW2 1
#define SW3 5
#define SW4 0
#define SW5 4
#define SW6 6
#define SW13 17
#define SW14 13
#define SW15 10
#define SW16 16
#define SW17 11
#define SW18 15
#define SW19 12

// IR Commands
#define EJC 0x691
#define TXT 0x151
#define DPL 0x6b1
#define CON 0xb91
#define SHF 0xad1
#define RPT 0x351
#define RWD 0xcd1
#define STP 0x1d1
#define FFW 0x2d1
#define PLY 0x4d1
#define PSE 0x9d1
#define PRV 0x0d1
#define NXT 0x8d1

unsigned long StartTime = 0;

void setup() {
  //  for (byte c=0; c++; c<20) {
  //    if (c != 3) pinMode (c, INPUT_PULLUP);
  //  }
  pinMode (SW1, INPUT_PULLUP);
  pinMode (SW2, INPUT_PULLUP);
  pinMode (SW3, INPUT_PULLUP);
  pinMode (SW4, INPUT_PULLUP);
  pinMode (SW5, INPUT_PULLUP);
  pinMode (SW6, INPUT_PULLUP);
  pinMode (SW13, INPUT_PULLUP);
  pinMode (SW14, INPUT_PULLUP);
  pinMode (SW15, INPUT_PULLUP);
  pinMode (SW16, INPUT_PULLUP);
  pinMode (SW17, INPUT_PULLUP);
  pinMode (SW18, INPUT_PULLUP);
  pinMode (SW19, INPUT_PULLUP);

  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW1), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW2), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW3), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW4), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW5), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW6), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW13), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW14), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW15), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW16), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW17), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW18), intrpt, CHANGE);
  attachPinChangeInterrupt(digitalPinToPinChangeInterrupt(SW19), intrpt, CHANGE);
  


  adc_disable(); // ADC uses ~320uA
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
}

void SendIR(unsigned int BTS) {
  for (int i = 0; i < 3; i++) {
    irsend.sendSony(BTS, 12);
    delay(25);
  }
}

void loop() {
  if ((long)(millis() - StartTime) <= 5000) {
    if (digitalRead(SW1) == LOW) {
      StartTime = millis();
      SendIR(EJC);
    }
    else if (digitalRead(SW2) == LOW) {
      StartTime = millis();
      SendIR(DPL);
    }
    else if (digitalRead(SW3) == LOW) {
      StartTime = millis();
      SendIR(TXT);
    }
    else if (digitalRead(SW4) == LOW) {
      StartTime = millis();
      SendIR(CON);
    }
    else if (digitalRead(SW5) == LOW) {
      StartTime = millis();
      SendIR(SHF);
    }
    else if (digitalRead(SW6) == LOW) {
      StartTime = millis();
      SendIR(RPT);
    }
    else if (digitalRead(SW13) == LOW) {
      StartTime = millis();
      SendIR(RWD);
    }
    else if (digitalRead(SW14) == LOW) {
      StartTime = millis();
      SendIR(STP);
    }
    else if (digitalRead(SW15) == LOW) {
      StartTime = millis();
      SendIR(FFW);
    }
    else if (digitalRead(SW16) == LOW) {
      StartTime = millis();
      SendIR(PLY);
    }
    else if (digitalRead(SW17) == LOW) {
      StartTime = millis();
      SendIR(PSE);
    }
    else if (digitalRead(SW18) == LOW) {
      StartTime = millis();
      SendIR(PRV);
    }
    else if (digitalRead(SW19) == LOW) {
      StartTime = millis();
      SendIR(NXT);
    }
  }
  else {
//    sei();
    sleep_enable();
    sleep_cpu();
//    cli();
  }
}



void intrpt(void) {
  StartTime = millis();
}
